class myPair<S,T> {
	S item1;
	T item2;
	public myPair(S s, T t){ item1 = s; item2 = t; }
	public myPair() {}
	myPair<T,S> flip() { return new myPair<T,S>(item2,item1); }
}

class IntSomethingPair<T> extends myPair<Integer,T> {} // Attn: doesn't compile if myPair has no default constructor!

class ListOfInts extends IntSomethingPair<ListOfInts> {}
class ListOfDoubles extends myPair<Double,ListOfDoubles> {}
class ListOfT<T> extends myPair<T,ListOfT<T>> {
	T get(int index){
		if(index==0) return item1;
		if(item2==null) return null;
		return item2.get(index-1);
	}
	T get2(int index){
		ListOfT<T> tmp = this;
		while(index-->0){
			tmp = tmp.item2;
			if(tmp == null) return null;
		}
		return tmp.item1;
	}
	void add(T t){
		ListOfT<T> tmp = this;
		if(tmp.item1==null) { tmp.item1 = t; return; }
		while(tmp.item2 != null) tmp = tmp.item2;
		tmp.item2 = new ListOfT<>();
		tmp.item2.item1 = t;
	}
}

class Test{
	public static void main(String [] args){
		ListOfInts l = new ListOfInts();
		l.item1 = 5;
		//l.item2.item1  = 7; //Compiles but null pointer exception!
		ListOfT<Integer> l2 = new ListOfT<>();
		for(int i=0; i<5; i++){
			l2.add(i);
		}
		for(int i=0; i<5; i++){
			System.out.println(l2.get2(i));
		}
	}
}
