class A<T> { 
	T t;  
	public void setT(T t){ this.t = t; }
	public T getT(){ return t; }
}
//class B extends A<T> { int x; } //-> wrong! T undefined
//class C<T,T> extends A<T> { int y; } //-> wrong! each type variable defined once
class D<T,K> extends A<T> { 
	K k; 
	public void setK(K k){ this.k = k; }
	public K getK(K k){ return k; }
}
class E { int x; }
class F<T> extends E { T t; }

class Test{
	public static void main(String [] args){
		A<Integer> aa = new A<>();
		A<Integer> ad = new D<>(); // Compiles OK!
		E ef = new F<>(); // Compiles OK!
		aa.setT(5);
		//aa.setT("abc"); // -> wrong!
		//((A<String>)aa).setT("abc"); // -> wrong!
		//((A<Object>)aa).setT("abc"); // -> wrong!

		//ad.setK("hello"); // -> wrong, of course, ad has declared type A
		((D<Integer,String>)ad).setK("hello"); //Compiles, but unchecked cast warning, for the compiler we are converting A<Integer> to D<Integer,String>
		//((D<Integer,Integer>)ad).setK("hello"); // -> wrong!
	}
}
